//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "uMain.h"
#include "mem.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
AnsiString IntToHexA(int Value, int digits)
{
        AnsiString Res = AnsiString::IntToHex(Value,digits);
        return Res.SubString(Res.Length()-digits+1,digits);
}
//---------------------------------------------------------------------------
void TForm1::UpdateLabels()
{
        Label3->Caption = FileName;
        Label4->Caption = DestFile;
}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{

}
//---------------------------------------------------------------------------
void __fastcall TForm1::bnEncodeClick(TObject *Sender)
{
        char USERKEY[32];
        keyInstance KEY;
        cipherInstance CIPHER;
        AnsiString HexKey = "";
        for(int i = 1; i <= AKey->Text.Length(); i++)
        {
                HexKey+=IntToHexA(short(AKey->Text[i]),2);
        }
        while(HexKey.Length()<32) HexKey+="00";
        setmem(USERKEY,32,0);
        strcpy(USERKEY,HexKey.c_str());


        cipherInit(&CIPHER,MODE_ECB,NULL);
        makeKey(&KEY,DIR_ENCRYPT,128,USERKEY);

        AnsiString StrKey;
        for(int Ro = 0; Ro<ROUNDS; Ro++)
        {
                StrKey = "";
                for(int i = 0; i < 4; i++)
                {
                        for(int j = 0; j<4; j++)
                                StrKey +=AnsiString::IntToHex(KEY.keySched[Ro][i][j],2)+" ";
                        StrKey += '\n';
                }
                ShowMessage(StrKey);
        }

        AnsiString S = AText->Lines->Text;
        SourceSize = S.Length();
        int BlockSize;
        BlockSize = (SourceSize%16==0)?SourceSize:((SourceSize/16)+1)*16;
        delete[] Source;
        delete[] Encoded;
        Source = new char[BlockSize];
        Encoded = new char[BlockSize];
        strcpy(Source,S.c_str());

        blockEncrypt(&CIPHER,&KEY,Source,BlockSize*8,Encoded);

        Encrypted->Clear();
        AnsiString Text = "";
        for(int i = 0; i < BlockSize; i++)
                Text+=Encoded[i];
        Encrypted->Lines->Add(Text);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EncodeFile(TObject *Sender)
{
        int handle = -1;
        int created = -1;
        handle = FileOpen(FileName,fmOpenRead);
        if(handle != -1)
        {
                created = FileCreate(DestFile);
                if(created!=-1)
                {
                        cipherInit(&ACIPHER,MODE_ECB,NULL);
                        makeKey(&AKEY,DIR_ENCRYPT,128,UserKey);
                        char s_buffer[16];
                        char d_buffer[16];
                        int count = 0;
                        do
                        {
                                setmem(s_buffer,16,0);
                                count = FileRead(handle,(char*)&s_buffer,16);
                                if(count>0)
                                {
                                        blockEncrypt(&ACIPHER,&AKEY,s_buffer,128,d_buffer);
                                        FileWrite(created,(char*)&d_buffer,16);
                                }
                        }while(count>0);
                        FileClose(created);
                }
                FileClose(handle);
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DecodeFile(TObject *Sender)
{
        int handle = -1;
        int created = -1;
        handle = FileOpen(FileName,fmOpenRead);
        if(handle != -1)
        {
                created = FileCreate(DestFile);
                if(created!=-1)
                {
                        cipherInit(&ACIPHER,MODE_ECB,NULL);
                        makeKey(&AKEY,DIR_DECRYPT,128,UserKey);
                        char s_buffer[16];
                        char d_buffer[16];
                        int count = 0;
                        do
                        {
                                setmem(s_buffer,16,0);
                                count = FileRead(handle,(char*)&s_buffer,16);
                                if(count>0)
                                {
                                        blockDecrypt(&ACIPHER,&AKEY,s_buffer,128,d_buffer);
                                        FileWrite(created,(char*)&d_buffer,16);
                                }
                        }while(count>0);
                        FileClose(created);
                }
                FileClose(handle);
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::eKeyChange(TObject *Sender)
{
        AnsiString HexKey = "";
        for(int i = 1; i <= eKey->Text.Length(); i++)
        {
                HexKey+=IntToHexA(short(eKey->Text[i]),2);
        }
        while(HexKey.Length()<32) HexKey+="00";
        setmem(UserKey,32,0);
        strcpy(UserKey,HexKey.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TForm1::N2Click(TObject *Sender)
{
        if(OpenDialog1->Execute())
                FileName = OpenDialog1->FileName;
        Form1->RadioGroup1Click(Form1);
        UpdateLabels();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioGroup1Click(TObject *Sender)
{
        switch(RadioGroup1->ItemIndex)
        {
                case 0:
                {
                        bnGO->OnClick = EncodeFile;
                        DestFile = FileName+".rijndael";
                        break;
                }
                case 1:
                {
                        bnGO->OnClick = DecodeFile;
                        if(ExtractFileExt(FileName)==".rijndael")
                        {
                                AnsiString name = ExtractFileName(FileName);
                                int i;
                                for(i = name.Length(); (i>0)&&(name[i]!='.'); i--);
                                name = name.SubString(1,i-1);
                                DestFile = ExtractFilePath(FileName)+name;
                        }
                        else
                        {
                                DestFile = FileName+"rijndael";
                        }
                }
        }
        UpdateLabels();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::bnDecodeClick(TObject *Sender)
{
        char USERKEY[32];
        keyInstance KEY;
        cipherInstance CIPHER;
        AnsiString HexKey = "";
        for(int i = 1; i <= DKey->Text.Length(); i++)
        {
                HexKey+=IntToHexA(short(DKey->Text[i]),2);
        }
        while(HexKey.Length()<32) HexKey+="00";
        setmem(USERKEY,32,0);
        strcpy(USERKEY,HexKey.c_str());

        makeKey(&KEY,DIR_DECRYPT,128,USERKEY);
        cipherInit(&CIPHER,MODE_ECB,NULL);

        int BlockSize;
        BlockSize = (SourceSize%16==0)?SourceSize:((SourceSize/16)+1)*16;

        delete[] Decoded;
        Decoded = new char[BlockSize];

        blockDecrypt(&CIPHER,&KEY,Encoded,BlockSize*8,Decoded);
        AnsiString Text="";
        Decrypted->Clear();
        for(int i = 0; i < SourceSize; i++)
                Text+=Decoded[i];
        Decrypted->Lines->Add(Text);
}
//---------------------------------------------------------------------------

